=== modified file 'NEWS'
--- NEWS	2009-05-21 14:06:43 +0000
+++ NEWS	2009-05-22 01:44:19 +0000
@@ -18,6 +18,8 @@
 Improvements
 ************
 
+* ``bzr branch --notree`` is now faster. (Ian Clatworthy)
+
 Bug Fixes
 *********
 

=== modified file 'bzrlib/revisiontree.py'
--- bzrlib/revisiontree.py	2009-05-06 05:36:28 +0000
+++ bzrlib/revisiontree.py	2009-05-19 00:20:46 +0000
@@ -45,7 +45,8 @@
         self._rules_searcher = None
 
     def supports_tree_reference(self):
-        return True
+        return getattr(self._repository._format, "supports_tree_reference",
+            False)
 
     def get_parent_ids(self):
         """See Tree.get_parent_ids.

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2009-05-07 05:08:46 +0000
+++ bzrlib/tree.py	2009-05-19 00:20:46 +0000
@@ -202,9 +202,10 @@
             specific_file_ids=specific_file_ids)
 
     def iter_references(self):
-        for path, entry in self.iter_entries_by_dir():
-            if entry.kind == 'tree-reference':
-                yield path, entry.file_id
+        if self.supports_tree_reference():
+            for path, entry in self.iter_entries_by_dir():
+                if entry.kind == 'tree-reference':
+                    yield path, entry.file_id
 
     def kind(self, file_id):
         raise NotImplementedError("Tree subclass %s must implement kind"

